/*
 * Copyright © 2021-2023 Fachhochschule für die Wirtschaft (FHDW) Hannover
 *
 * This file is part of ipspiel24-tictactoe-core.
 *
 * ipspiel24-tictactoe-core is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * ipspiel24-tictactoe-core is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * ipspiel24-tictactoe-core. If not, see <http://www.gnu.org/licenses/>.
 */
package de.fhdw.gaming.ipspiel24.tictactoe.core.moves.factory;

import de.fhdw.gaming.ipspiel24.tictactoe.core.domain.TicTacToePosition;
import de.fhdw.gaming.ipspiel24.tictactoe.core.moves.TicTacToeMove;

/**
 * Allows to create Tic Tac Toe moves.
 */
public interface TicTacToeMoveFactory {

    /**
     * Creates a move that places a cross or nought on the Tic Tac Toe board.
     *
     * @param cross         {@code true} if a cross is to be made, {@code false} chooses a nought instead.
     * @param tokenPosition The position of the field having its state changed. It must point to an empty field.
     */
    TicTacToeMove createPlaceMarkMove(boolean cross, TicTacToePosition tokenPosition);
}
